Index: issm/trunk-jpl/src/m/parameterization/setflowequation.m
===================================================================
--- issm/trunk-jpl/src/m/parameterization/setflowequation.m	(revision 15563)
+++ issm/trunk-jpl/src/m/parameterization/setflowequation.m	(revision 15564)
@@ -3,13 +3,13 @@
 %
 %   This routine works like plotmodel: it works with an even number of inputs
-%   'hutter','macayeal','l1l2','pattyn','stokes' and 'fill' are the possible options
+%   'SIA','SSA','L1L2','HO','FS' and 'fill' are the possible options
 %   that must be followed by the corresponding exp file or flags list
 %   It can either be a domain file (argus type, .exp extension), or an array of element flags. 
 %   If user wants every element outside the domain to be 
-%   setflowequationd, add '~' to the name of the domain file (ex: '~Pattyn.exp');
+%   setflowequationd, add '~' to the name of the domain file (ex: '~HO.exp');
 %   an empty string '' will be considered as an empty domain
 %   a string 'all' will be considered as the entire domain
 %   You can specify the type of coupling, 'penalties' or 'tiling', to use with the input 'coupling'
-%   NB: l1l2 cannot currently be coupled to any other ice flow model
+%   NB: L1L2 cannot currently be coupled to any other ice flow model
 %
 %   Usage:
@@ -17,6 +17,6 @@
 %
 %   Example:
-%      md=setflowequation(md,'pattyn','Pattyn.exp','macayeal',md.mask.elementonfloatingice,'fill','hutter');
-%      md=setflowequation(md,'pattyn','Pattyn.exp',fill','hutter','coupling','tiling');
+%      md=setflowequation(md,'HO','HO.exp','SSA',md.mask.elementonfloatingice,'fill','SIA');
+%      md=setflowequation(md,'HO','HO.exp',fill','SIA','coupling','tiling');
 
 %some checks on list of arguments
@@ -36,96 +36,97 @@
 
 %recover elements distribution
-hutterflag   = FlagElements(md,getfieldvalue(options,'hutter',''));
-macayealflag = FlagElements(md,getfieldvalue(options,'macayeal',''));
-pattynflag   = FlagElements(md,getfieldvalue(options,'pattyn',''));
-l1l2flag     = FlagElements(md,getfieldvalue(options,'l1l2',''));
-stokesflag   = FlagElements(md,getfieldvalue(options,'stokes',''));
-filltype     = getfieldvalue(options,'fill','none');
+SIAflag  = FlagElements(md,getfieldvalue(options,'SIA',''));
+SSAflag  = FlagElements(md,getfieldvalue(options,'SSA',''));
+HOflag   = FlagElements(md,getfieldvalue(options,'HO',''));
+L1L2flag = FlagElements(md,getfieldvalue(options,'L1L2',''));
+FSflag   = FlagElements(md,getfieldvalue(options,'FS',''));
+filltype = getfieldvalue(options,'fill','none');
+displayunused(options);
 
 %Flag the elements that have not been flagged as filltype
-if strcmpi(filltype,'hutter'),
-	hutterflag(find(~(macayealflag | pattynflag)))=1;
-elseif strcmpi(filltype,'macayeal'),
-	macayealflag(find(~(hutterflag | pattynflag | stokesflag)))=1;
-elseif strcmpi(filltype,'pattyn'),
-	pattynflag(find(~(hutterflag | macayealflag | stokesflag)))=1;
+if strcmpi(filltype,'SIA'),
+	SIAflag(find(~(SSAflag | HOflag)))=1;
+elseif strcmpi(filltype,'SSA'),
+	SSAflag(find(~(SIAflag | HOflag | FSflag)))=1;
+elseif strcmpi(filltype,'HO'),
+	HOflag(find(~(SIAflag | SSAflag | FSflag)))=1;
 end
 
 %check that each element has at least one flag
-if any(hutterflag+macayealflag+pattynflag+l1l2flag+stokesflag==0),
+if any(SIAflag+SSAflag+HOflag+L1L2flag+FSflag==0),
 	error('elements type not assigned, must be specified')
 end
 
 %check that each element has only one flag
-if any(hutterflag+macayealflag+pattynflag+l1l2flag+stokesflag>1),
+if any(SIAflag+SSAflag+HOflag+L1L2flag+FSflag>1),
 	disp('setflowequation warning message: some elements have several types, higher order type is used for them')
-	hutterflag(find(hutterflag & macayealflag))=0;
-	hutterflag(find(hutterflag & pattynflag))=0;
-	macayealflag(find(macayealflag & pattynflag))=0;
-end
-
-%check that l1l2 is not coupled to any other model for now
-if any(l1l2flag) & any(hutterflag | macayealflag | pattynflag | stokesflag)
-	error('l1l2 cannot be coupled to any other model');
-end
-
-%Check that no l1l2 or pattyn or stokes for 2d mesh
+	SIAflag(find(SIAflag & SSAflag))=0;
+	SIAflag(find(SIAflag & HOflag))=0;
+	SSAflag(find(SSAflag & HOflag))=0;
+end
+
+%check that L1L2 is not coupled to any other model for now
+if any(L1L2flag) & any(SIAflag | SSAflag | HOflag | FSflag)
+	error('L1L2 cannot be coupled to any other model');
+end
+
+%Check that no L1L2 or HO or FS for 2d mesh
 if (md.mesh.dimension==2),
-	if any(l1l2flag | stokesflag | pattynflag)
-		error('stokes and pattyn elements not allowed in 2d mesh, extrude it first')
-	end
-end
-
-%Stokes can only be used alone for now:
-if any(stokesflag) &any(hutterflag),
-	error('stokes cannot be used with any other model for now, put stokes everywhere')
+	if any(L1L2flag | FSflag | HOflag)
+		error('FS and HO elements not allowed in 2d mesh, extrude it first')
+	end
+end
+
+%FS can only be used alone for now:
+if any(FSflag) &any(SIAflag),
+	error('FS cannot be used with any other model for now, put FS everywhere')
 end
 
 %Initialize node fields
-nodeonhutter=zeros(md.mesh.numberofvertices,1);
-nodeonhutter(md.mesh.elements(find(hutterflag),:))=1;
-nodeonmacayeal=zeros(md.mesh.numberofvertices,1);
-nodeonmacayeal(md.mesh.elements(find(macayealflag),:))=1;
-nodeonpattyn=zeros(md.mesh.numberofvertices,1);
-nodeonpattyn(md.mesh.elements(find(pattynflag),:))=1;
-nodeonl1l2=zeros(md.mesh.numberofvertices,1);
-nodeonl1l2(md.mesh.elements(find(l1l2flag),:))=1;
-nodeonstokes=zeros(md.mesh.numberofvertices,1);
+nodeonSIA=zeros(md.mesh.numberofvertices,1);
+nodeonSIA(md.mesh.elements(find(SIAflag),:))=1;
+nodeonSSA=zeros(md.mesh.numberofvertices,1);
+nodeonSSA(md.mesh.elements(find(SSAflag),:))=1;
+nodeonHO=zeros(md.mesh.numberofvertices,1);
+nodeonHO(md.mesh.elements(find(HOflag),:))=1;
+nodeonL1L2=zeros(md.mesh.numberofvertices,1);
+nodeonL1L2(md.mesh.elements(find(L1L2flag),:))=1;
+nodeonFS=zeros(md.mesh.numberofvertices,1);
 noneflag=zeros(md.mesh.numberofelements,1);
 
-%First modify stokesflag to get rid of elements contrained everywhere (spc + border with pattyn or macayeal)
-if any(stokesflag),
-	fullspcnodes=double((~isnan(md.diagnostic.spcvx)+~isnan(md.diagnostic.spcvy)+~isnan(md.diagnostic.spcvz))==3 | (nodeonpattyn & nodeonstokes));         %find all the nodes on the boundary of the domain without icefront
+%First modify FSflag to get rid of elements contrained everywhere (spc + border with HO or SSA)
+if any(FSflag),
+	fullspcnodes=double((~isnan(md.diagnostic.spcvx)+~isnan(md.diagnostic.spcvy)+~isnan(md.diagnostic.spcvz))==3 | (nodeonHO & nodeonFS));         %find all the nodes on the boundary of the domain without icefront
 	fullspcelems=double(sum(fullspcnodes(md.mesh.elements),2)==6);         %find all the nodes on the boundary of the domain without icefront
-	stokesflag(find(fullspcelems))=0;
-	nodeonstokes(md.mesh.elements(find(stokesflag),:))=1;
-end
-
-%Then complete with NoneApproximation or the other model used if there is no stokes
-if any(stokesflag), 
-	if any(pattynflag), %fill with pattyn
-		pattynflag(~stokesflag)=1;
-		nodeonpattyn(md.mesh.elements(find(pattynflag),:))=1;
-	elseif any(macayealflag), %fill with macayeal
-		macayealflag(~stokesflag)=1;
-		nodeonmacayeal(md.mesh.elements(find(macayealflag),:))=1;
+	FSflag(find(fullspcelems))=0;
+	nodeonFS(md.mesh.elements(find(FSflag),:))=1;
+end
+
+%Then complete with NoneApproximation or the other model used if there is no FS
+if any(FSflag), 
+	if any(HOflag), %fill with HO
+		HOflag(~FSflag)=1;
+		nodeonHO(md.mesh.elements(find(HOflag),:))=1;
+	elseif any(SSAflag), %fill with SSA
+		SSAflag(~FSflag)=1;
+		nodeonSSA(md.mesh.elements(find(SSAflag),:))=1;
 	else %fill with none 
-		noneflag(find(~stokesflag))=1;
-	end
-end
-
-%Now take care of the coupling between MacAyeal and Pattyn
+		noneflag(find(~FSflag))=1;
+	end
+end
+
+%Now take care of the coupling between MacAyeal and HO
 md.diagnostic.vertex_pairing=[];
-nodeonmacayealpattyn=zeros(md.mesh.numberofvertices,1);
-nodeonpattynstokes=zeros(md.mesh.numberofvertices,1);
-nodeonmacayealstokes=zeros(md.mesh.numberofvertices,1);
-macayealpattynflag=zeros(md.mesh.numberofelements,1);
-macayealstokesflag=zeros(md.mesh.numberofelements,1);
-pattynstokesflag=zeros(md.mesh.numberofelements,1);
+nodeonSSAHO=zeros(md.mesh.numberofvertices,1);
+nodeonHOFS=zeros(md.mesh.numberofvertices,1);
+nodeonSSAFS=zeros(md.mesh.numberofvertices,1);
+SSAHOflag=zeros(md.mesh.numberofelements,1);
+SSAFSflag=zeros(md.mesh.numberofelements,1);
+HOFSflag=zeros(md.mesh.numberofelements,1);
 if strcmpi(coupling_method,'penalties'),
-	%Create the border nodes between Pattyn and MacAyeal and extrude them
+	%Create the border nodes between HO and MacAyeal and extrude them
 	numnodes2d=md.mesh.numberofvertices2d;
 	numlayers=md.mesh.numberoflayers;
-	bordernodes2d=find(nodeonpattyn(1:numnodes2d) & nodeonmacayeal(1:numnodes2d)); %Nodes connected to two different types of elements
+	bordernodes2d=find(nodeonHO(1:numnodes2d) & nodeonSSA(1:numnodes2d)); %Nodes connected to two different types of elements
 
 	%initialize and fill in penalties structure
@@ -138,164 +139,164 @@
 	end
 elseif strcmpi(coupling_method,'tiling'),
-	if any(macayealflag) & any(pattynflag), %coupling macayeal pattyn
+	if any(SSAflag) & any(HOflag), %coupling SSA HO
 		%Find node at the border
-		nodeonmacayealpattyn(find(nodeonmacayeal & nodeonpattyn))=1;
-		%Macayeal elements in contact with this layer become MacAyealPattyn elements
-		matrixelements=ismember(md.mesh.elements,find(nodeonmacayealpattyn));
+		nodeonSSAHO(find(nodeonSSA & nodeonHO))=1;
+		%SSA elements in contact with this layer become MacAyealHO elements
+		matrixelements=ismember(md.mesh.elements,find(nodeonSSAHO));
 		commonelements=sum(matrixelements,2)~=0;
-		commonelements(find(pattynflag))=0; %only one layer: the elements previously in macayeal
-		macayealflag(find(commonelements))=0; %these elements are now macayealpattynelements
-		macayealpattynflag(find(commonelements))=1;
-		nodeonmacayeal(:)=0;
-		nodeonmacayeal(md.mesh.elements(find(macayealflag),:))=1;
+		commonelements(find(HOflag))=0; %only one layer: the elements previously in SSA
+		SSAflag(find(commonelements))=0; %these elements are now SSAHOelements
+		SSAHOflag(find(commonelements))=1;
+		nodeonSSA(:)=0;
+		nodeonSSA(md.mesh.elements(find(SSAflag),:))=1;
 
 		%rule out elements that don't touch the 2 boundaries
-		pos=find(macayealpattynflag);
+		pos=find(SSAHOflag);
 		elist=zeros(length(pos),1);
-		elist = elist + any(sum(nodeonmacayeal(md.mesh.elements(pos,:)),2),2);
-		elist = elist - any(sum(nodeonpattyn(md.mesh.elements(pos,:))  ,2),2);
+		elist = elist + any(sum(nodeonSSA(md.mesh.elements(pos,:)),2),2);
+		elist = elist - any(sum(nodeonHO(md.mesh.elements(pos,:))  ,2),2);
 		pos1=find(elist==1);
-		macayealflag(pos(pos1))=1;
-		macayealpattynflag(pos(pos1))=0;
+		SSAflag(pos(pos1))=1;
+		SSAHOflag(pos(pos1))=0;
 		pos2=find(elist==-1);
-		pattynflag(pos(pos2))=1;
-		macayealpattynflag(pos(pos2))=0;
+		HOflag(pos(pos2))=1;
+		SSAHOflag(pos(pos2))=0;
 
 		%Recompute nodes associated to these elements
-		nodeonmacayeal(:)=0;
-		nodeonmacayeal(md.mesh.elements(find(macayealflag),:))=1;
-		nodeonpattyn(:)=0;
-		nodeonpattyn(md.mesh.elements(find(pattynflag),:))=1;
-		nodeonmacayealpattyn(:)=0;
-		nodeonmacayealpattyn(md.mesh.elements(find(macayealpattynflag),:))=1;
-
-	elseif any(pattynflag) & any(stokesflag), %coupling pattyn stokes
+		nodeonSSA(:)=0;
+		nodeonSSA(md.mesh.elements(find(SSAflag),:))=1;
+		nodeonHO(:)=0;
+		nodeonHO(md.mesh.elements(find(HOflag),:))=1;
+		nodeonSSAHO(:)=0;
+		nodeonSSAHO(md.mesh.elements(find(SSAHOflag),:))=1;
+
+	elseif any(HOflag) & any(FSflag), %coupling HO FS
 		%Find node at the border
-		nodeonpattynstokes(find(nodeonpattyn & nodeonstokes))=1;
-		%Stokes elements in contact with this layer become PattynStokes elements
-		matrixelements=ismember(md.mesh.elements,find(nodeonpattynstokes));
+		nodeonHOFS(find(nodeonHO & nodeonFS))=1;
+		%FS elements in contact with this layer become HOFS elements
+		matrixelements=ismember(md.mesh.elements,find(nodeonHOFS));
 		commonelements=sum(matrixelements,2)~=0;
-		commonelements(find(pattynflag))=0; %only one layer: the elements previously in macayeal
-		stokesflag(find(commonelements))=0; %these elements are now macayealpattynelements
-		pattynstokesflag(find(commonelements))=1;
-		nodeonstokes=zeros(md.mesh.numberofvertices,1);
-		nodeonstokes(md.mesh.elements(find(stokesflag),:))=1;
+		commonelements(find(HOflag))=0; %only one layer: the elements previously in SSA
+		FSflag(find(commonelements))=0; %these elements are now SSAHOelements
+		HOFSflag(find(commonelements))=1;
+		nodeonFS=zeros(md.mesh.numberofvertices,1);
+		nodeonFS(md.mesh.elements(find(FSflag),:))=1;
 
 		%rule out elements that don't touch the 2 boundaries
-		pos=find(pattynstokesflag);
+		pos=find(HOFSflag);
 		elist=zeros(length(pos),1);
-		elist = elist + any(sum(nodeonstokes(md.mesh.elements(pos,:)),2),2);
-		elist = elist - any(sum(nodeonpattyn(md.mesh.elements(pos,:)),2),2);
+		elist = elist + any(sum(nodeonFS(md.mesh.elements(pos,:)),2),2);
+		elist = elist - any(sum(nodeonHO(md.mesh.elements(pos,:)),2),2);
 		pos1=find(elist==1);
-		stokesflag(pos(pos1))=1;
-		pattynstokesflag(pos(pos1))=0;
+		FSflag(pos(pos1))=1;
+		HOFSflag(pos(pos1))=0;
 		pos2=find(elist==-1);
-		pattynflag(pos(pos2))=1;
-		pattynstokesflag(pos(pos2))=0;
+		HOflag(pos(pos2))=1;
+		HOFSflag(pos(pos2))=0;
 
 		%Recompute nodes associated to these elements
-		nodeonstokes(:)=0;
-		nodeonstokes(md.mesh.elements(find(stokesflag),:))=1;
-		nodeonpattyn(:)=0;
-		nodeonpattyn(md.mesh.elements(find(pattynflag),:))=1;
-		nodeonpattynstokes(:)=0;
-		nodeonpattynstokes(md.mesh.elements(find(pattynstokesflag),:))=1;
-
-	elseif any(stokesflag) & any(macayealflag),
+		nodeonFS(:)=0;
+		nodeonFS(md.mesh.elements(find(FSflag),:))=1;
+		nodeonHO(:)=0;
+		nodeonHO(md.mesh.elements(find(HOflag),:))=1;
+		nodeonHOFS(:)=0;
+		nodeonHOFS(md.mesh.elements(find(HOFSflag),:))=1;
+
+	elseif any(FSflag) & any(SSAflag),
 		%Find node at the border
-		nodeonmacayealstokes(find(nodeonmacayeal & nodeonstokes))=1;
-		%Stokes elements in contact with this layer become MacAyealStokes elements
-		matrixelements=ismember(md.mesh.elements,find(nodeonmacayealstokes));
+		nodeonSSAFS(find(nodeonSSA & nodeonFS))=1;
+		%FS elements in contact with this layer become MacAyealFS elements
+		matrixelements=ismember(md.mesh.elements,find(nodeonSSAFS));
 		commonelements=sum(matrixelements,2)~=0;
-		commonelements(find(macayealflag))=0; %only one layer: the elements previously in macayeal
-		stokesflag(find(commonelements))=0; %these elements are now macayealmacayealelements
-		macayealstokesflag(find(commonelements))=1;
-		nodeonstokes=zeros(md.mesh.numberofvertices,1);
-		nodeonstokes(md.mesh.elements(find(stokesflag),:))=1;
+		commonelements(find(SSAflag))=0; %only one layer: the elements previously in SSA
+		FSflag(find(commonelements))=0; %these elements are now SSASSAelements
+		SSAFSflag(find(commonelements))=1;
+		nodeonFS=zeros(md.mesh.numberofvertices,1);
+		nodeonFS(md.mesh.elements(find(FSflag),:))=1;
 
 		%rule out elements that don't touch the 2 boundaries
-		pos=find(macayealstokesflag);
+		pos=find(SSAFSflag);
 		elist=zeros(length(pos),1);
-		elist = elist + any(sum(nodeonmacayeal(md.mesh.elements(pos,:)),2),2);
-		elist = elist - any(sum(nodeonstokes(md.mesh.elements(pos,:))  ,2),2);
+		elist = elist + any(sum(nodeonSSA(md.mesh.elements(pos,:)),2),2);
+		elist = elist - any(sum(nodeonFS(md.mesh.elements(pos,:))  ,2),2);
 		pos1=find(elist==1);
-		macayealflag(pos(pos1))=1;
-		macayealstokesflag(pos(pos1))=0;
+		SSAflag(pos(pos1))=1;
+		SSAFSflag(pos(pos1))=0;
 		pos2=find(elist==-1);
-		stokesflag(pos(pos2))=1;
-		macayealstokesflag(pos(pos2))=0;
+		FSflag(pos(pos2))=1;
+		SSAFSflag(pos(pos2))=0;
 
 		%Recompute nodes associated to these elements
-		nodeonmacayeal(:)=0;
-		nodeonmacayeal(md.mesh.elements(find(macayealflag),:))=1;
-		nodeonstokes(:)=0;
-		nodeonstokes(md.mesh.elements(find(stokesflag),:))=1;
-		nodeonmacayealstokes(:)=0;
-		nodeonmacayealstokes(md.mesh.elements(find(macayealstokesflag),:))=1;
-
-	elseif any(stokesflag) & any(hutterflag),
+		nodeonSSA(:)=0;
+		nodeonSSA(md.mesh.elements(find(SSAflag),:))=1;
+		nodeonFS(:)=0;
+		nodeonFS(md.mesh.elements(find(FSflag),:))=1;
+		nodeonSSAFS(:)=0;
+		nodeonSSAFS(md.mesh.elements(find(SSAFSflag),:))=1;
+
+	elseif any(FSflag) & any(SIAflag),
 		error('type of coupling not supported yet');
 	end
 end
 
-%Create MacaAyealPattynApproximation where needed
+%Create MacaAyealHOApproximation where needed
 md.flowequation.element_equation=zeros(md.mesh.numberofelements,1);
 md.flowequation.element_equation(find(noneflag))=0;
-md.flowequation.element_equation(find(hutterflag))=1;
-md.flowequation.element_equation(find(macayealflag))=2;
-md.flowequation.element_equation(find(l1l2flag))=8;
-md.flowequation.element_equation(find(pattynflag))=3;
-md.flowequation.element_equation(find(stokesflag))=4;
-md.flowequation.element_equation(find(macayealpattynflag))=5;
-md.flowequation.element_equation(find(macayealstokesflag))=6;
-md.flowequation.element_equation(find(pattynstokesflag))=7;
+md.flowequation.element_equation(find(SIAflag))=1;
+md.flowequation.element_equation(find(SSAflag))=2;
+md.flowequation.element_equation(find(L1L2flag))=8;
+md.flowequation.element_equation(find(HOflag))=3;
+md.flowequation.element_equation(find(FSflag))=4;
+md.flowequation.element_equation(find(SSAHOflag))=5;
+md.flowequation.element_equation(find(SSAFSflag))=6;
+md.flowequation.element_equation(find(HOFSflag))=7;
 
 %border
-md.flowequation.borderpattyn=nodeonpattyn;
-md.flowequation.bordermacayeal=nodeonmacayeal;
-md.flowequation.borderstokes=nodeonstokes;
+md.flowequation.borderHO=nodeonHO;
+md.flowequation.borderSSA=nodeonSSA;
+md.flowequation.borderFS=nodeonFS;
 
 %Create vertices_type
 md.flowequation.vertex_equation=zeros(md.mesh.numberofvertices,1);
-pos=find(nodeonmacayeal);
+pos=find(nodeonSSA);
 md.flowequation.vertex_equation(pos)=2;
-pos=find(nodeonl1l2);
+pos=find(nodeonL1L2);
 md.flowequation.vertex_equation(pos)=8;
-pos=find(nodeonpattyn);
+pos=find(nodeonHO);
 md.flowequation.vertex_equation(pos)=3;
-pos=find(nodeonhutter);
+pos=find(nodeonSIA);
 md.flowequation.vertex_equation(pos)=1;
-pos=find(nodeonmacayealpattyn);
+pos=find(nodeonSSAHO);
 md.flowequation.vertex_equation(pos)=5;
-pos=find(nodeonstokes);
+pos=find(nodeonFS);
 md.flowequation.vertex_equation(pos)=4;
-if any(stokesflag),
-	pos=find(~nodeonstokes);
-	if(~any(pattynflag) & ~any(macayealflag)),
+if any(FSflag),
+	pos=find(~nodeonFS);
+	if(~any(HOflag) & ~any(SSAflag)),
 		md.flowequation.vertex_equation(pos)=0;
 	end
 end
-pos=find(nodeonpattynstokes);
+pos=find(nodeonHOFS);
 md.flowequation.vertex_equation(pos)=7;
-pos=find(nodeonmacayealstokes);
+pos=find(nodeonSSAFS);
 md.flowequation.vertex_equation(pos)=6;
 
 %figure out solution types
-md.flowequation.ishutter=double(any(md.flowequation.element_equation==1));
-md.flowequation.ismacayeal=double(any(md.flowequation.element_equation==2));
-md.flowequation.ispattyn=double(any(md.flowequation.element_equation==3));
-md.flowequation.isl1l2=double(any(md.flowequation.element_equation==8));
-md.flowequation.isstokes=double(any(md.flowequation.element_equation==4));
+md.flowequation.isSIA  = double(any(md.flowequation.element_equation == 1));
+md.flowequation.isSSA  = double(any(md.flowequation.element_equation == 2));
+md.flowequation.isHO   = double(any(md.flowequation.element_equation == 3));
+md.flowequation.isL1L2 = double(any(md.flowequation.element_equation == 8));
+md.flowequation.isFS   = double(any(md.flowequation.element_equation == 4));
 
 return
 
 %Check that tiling can work:
-if any(md.flowequation.bordermacayeal) & any(md.flowequation.borderpattyn) & any(md.flowequation.borderpattyn + md.flowequation.bordermacayeal ~=1),
+if any(md.flowequation.borderSSA) & any(md.flowequation.borderHO) & any(md.flowequation.borderHO + md.flowequation.borderSSA ~=1),
 	error('error coupling domain too irregular');
 end
-if any(md.flowequation.bordermacayeal) & any(md.flowequation.borderstokes) & any(md.flowequation.borderstokes + md.flowequation.bordermacayeal ~=1),
+if any(md.flowequation.borderSSA) & any(md.flowequation.borderFS) & any(md.flowequation.borderFS + md.flowequation.borderSSA ~=1),
 	error('error coupling domain too irregular');
 end
-if any(md.flowequation.borderstokes) & any(md.flowequation.borderpattyn) & any(md.flowequation.borderpattyn + md.flowequation.borderstokes~=1),
+if any(md.flowequation.borderFS) & any(md.flowequation.borderHO) & any(md.flowequation.borderHO + md.flowequation.borderFS~=1),
 	error('error coupling domain too irregular');
 end
